#!/bin/bash
#
# Copyright (c) 2009-2011 SNT Brugge. All rights reserved.
#
# Author: Dany Pinoy <dany.p@snt-brugge.be>
#
# Create a Live USB disk
#
dialoogtitel="Live USB Flash Drive aanmaken"
if [ -d /livecd ]; then # opgestart vanaf Live Linux
	isofile=$(more /proc/mounts | grep "/livecd" | cut -d ' ' -f 1)
	password=""
else
	isofile=$(kdialog --title "Selecteer het Live ISO-bestand" --getopenfilename ~ "*.iso")
	if [ $? == "1" ]; then
		exit
	fi
	password=$(kdialog --title "$dialoogtitel" --password "Om de Live USB aan te maken, zijn root-rechten nodig.")
	if [ $? == "1" ]; then
		exit
	fi
fi
if [ /dev/$(ls -l /dev/dvd | awk '{ print $11 }') == $isofile ]; then # opgestart vanaf DVD
    for i in $(echo $password | su -c "/sbin/fdisk -l" | /usr/bin/grep "/dev/[sh]d[ab][123456789]" | /usr/bin/grep "7  HPFS/NTFS" | /usr/bin/cut -f 1 -d ' '); do
      echo $password | su -c "/bin/mkdir $(/bin/echo $i | /usr/bin/sed -e s/dev/mnt/)"
      echo $password | su -c "/bin/mount -t ntfs-3g $i $(/bin/echo $i | /usr/bin/sed -e s/dev/mnt/)"
    done
    # Aanwezige Linux-partities mounten
    for i in $(echo $password | su -c "/sbin/fdisk -l" | /usr/bin/grep "/dev/[sh]d[ab][123456789]" | /usr/bin/grep "83  Linux" | /usr/bin/cut -f 1 -d ' '); do
      echo $password | su -c "/bin/mkdir $(/bin/echo $i | /usr/bin/sed -e s/dev/mnt/)"
      echo $password | su -c "/bin/mount $i $(/bin/echo $i | /usr/bin/sed -e s/dev/mnt/)"
    done
    # Aanwezige FAT-partities mounten
    for i in $(echo $password | su -c "/sbin/fdisk -l" | /usr/bin/grep "/dev/[sh]d[ab][123456789]" | /usr/bin/grep "b  W95 FAT" | /usr/bin/cut -f 1 -d ' '); do
      echo $password | su -c "/bin/mkdir $(/bin/echo $i | /usr/bin/sed -e s/dev/mnt/)"
      echo $password | su -c "/bin/mount $i $(/bin/echo $i | /usr/bin/sed -e s/dev/mnt/)"
    done
    isofile=$(kdialog --title "Selecteer het Live ISO-bestand" --getopenfilename /mnt/ "*.iso")
    if [ $? == "1" ]; then
      exit
    fi
fi 
kdialog --title "$dialoogtitel" --msgbox "Steek de aan te maken USB Flash Drive in de computer."
sleep 3
for i in /sys/class/block/sd?; do 
  /sbin/udevadm info -a -p $i | grep -qx '    SUBSYSTEMS=="usb"' && radiolist=$radiolist${i##*/}" \""$(/sbin/udevadm info --query=property -p $i | grep ID_MODEL= | /usr/bin/cut -f 2 -d '=')"\" off "; 
done
# of
# for i in *; do 
#   [[ $(cd $i; pwd -P) = */usb*/* ]] && echo $i; 
# done
device="/dev/"$(eval kdialog --title "'Live USB Flash Drive aanmaken'" --radiolist "'Selecteer uw USB Flash Drive'" $radiolist)
if [ $? == "1" ]; then
  exit
fi

if [ $(echo $isofile | cut -c -8) == $device ]; then
  kdialog --title "$dialoogtitel" --sorry "Doel en bron zijn dezelfde USB-stick.\n\nLive USB Flash Drive aanmaken wordt afgebroken."
  exit
fi 
echo $password | su -c "/bin/umount -l $device"
kdialog --title "$dialoogtitel" --yesno "Bij het aanmaken van de Live USB Flash Drive zullen alle gegevens op de USB Flash Drive verloren gaan?\n\nWilt U nog doorgaan?"
if [ $? == "1" ]; then
  exit
fi

if [ -f $isofile] ]; then
  isogrootte=`ls -s --block-size=M $isofile | cut -f 1 -d 'M'`
else
  isogrootte=$[`echo $password | su -c "/sbin/fdisk -s $isofile"` / 1024]
fi

dbusref=$(kdialog --title "$dialoogtitel" --progressbar "Aanmaken Live USB Flash Drive op $device" $[$isogrootte / 4]) # 755 is de grootte van het iso-bestand in MB
for i in `seq 0 $[$isogrootte / 4]`; # 755 is de grootte van het iso-bestand in MB
do 
  echo $password | su -c "dd if=$isofile of=$device bs=4M seek=$i skip=$i count=1"
#  echo $password | su -c "dd if=$isofile of=/tmp/test.iso bs=4M seek=$i skip=$i count=1" # test
  qdbus $dbusref org.freedesktop.DBus.Properties.Set org.kde.kdialog.ProgressDialog value $i
done
sync
qdbus $dbusref org.kde.kdialog.ProgressDialog.close

kdialog --title "$dialoogtitel" --msgbox "De persistente (beschrijfbare) Live USB Flash Drive is klaar om gebruikt te worden."