#!/bin/bash
#
# Copyright (c) 2009-2011 SNT Brugge. All rights reserved.
#
# Author: Dany Pinoy <dany.p@snt-brugge.be>
#
# Wipe a Live USB disk
#
dialoogtitel="Live USB Flash Drive wissen"
if [ -d /livecd ]; then
	password=""
else
	password=$(kdialog --title "$dialoogtitel" --password "Om de Live USB te wissen, zijn root-rechten nodig.")
	if [ $? == "1" ]; then
		exit
	fi
fi
isofile=$(more /proc/mounts | grep "/livecd" | cut -d ' ' -f 1)
kdialog --title "$dialoogtitel" --msgbox "Steek de te wissen USB Flash Drive in de computer."
sleep 3
for i in /sys/class/block/sd?; do 
  /sbin/udevadm info -a -p $i | grep -qx '    SUBSYSTEMS=="usb"' && radiolist=$radiolist${i##*/}" \""$(/sbin/udevadm info --query=property -p $i | grep ID_MODEL= | /usr/bin/cut -f 2 -d '=')"\" off "; 
done
# of
# for i in *; do 
#   [[ $(cd $i; pwd -P) = */usb*/* ]] && echo $i; 
# done
device="/dev/"$(eval kdialog --title "'Live USB Flash Drive wissen'" --radiolist "'Selecteer uw USB Flash Drive'" $radiolist)
if [ $? == "1" ]; then
  exit
fi
if [ $(echo $isofile | cut -c -8) == $device ]; then
  kdialog --title "$dialoogtitel" --sorry "Live USB Flash drive wordt gebruikt.\n\nLive USB Flash Drive verwijderen wordt afgebroken."
  exit
fi 
kdialog --title "$dialoogtitel" --yesno "Bij het wissen van de Live USB Flash Drive zullen alle gegevens op de USB Flash Drive verloren gaan?\n\nWilt U nog doorgaan?"
if [ $? == "1" ]; then
  exit
fi

mount | grep $device
if [ $? == "0" ]; then
  kdialog --title "$dialoogtitel" --sorry "De te wissen USB Flash Drive is gekoppeld.\n\nLive USB Flash Drive verwijderen wordt afgebroken."
  exit
fi

dbusref=$(kdialog --title "$dialoogtitel" --progressbar "Wissen Live USB Flash Drive $device" 60)
echo $password | su -c "mkfs.vfat -I -F 32 ${device}"
qdbus $dbusref org.kde.kdialog.ProgressDialog.close

kdialog --title "$dialoogtitel" --msgbox "De Live USB Flash Drive kan nu terug als gewone USB Flash Drive gebruikt worden."